/*
**	execAssembla.c
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "opencasl.h"

/*	oca.c	*/
extern	char	inbuf[BUFSIZ];
extern	FILE	*obj, *prn;
extern	int		lineNo;
extern	char	errorMsg[BUFSIZ];
extern	int		errorFlag, nError;

void displayError(char *msg)
{
	fprintf(prn, "ERROR:\t%s\n", msg);
	fprintf(stderr, "ERROR:\t%s\n", msg);
	nError++;
}

word getAddress(char *s)
{
	word	result = 0;

	errorFlag = FALSE;
	if (isalpha(*s) || *s == '=') {
		if ((result = getLabelAddress(s)) == 0) {
			sprintf(errorMsg, "%3d行目: ラベル\"%s\"が未定義です", lineNo, s);
			displayError(errorMsg);
			errorFlag = TRUE;
		}
	} else {
		result = getWord(s);
	}
	return result;
}

word execAsm0(word address, int op, char *items[], int p)
{
	int		t;
	word	ope1 = 0;
	word	ope2 = 0;
	
	errorFlag = FALSE;
	ope1 = getOpeCode(op);
	p++;
	
	if (items[p] == NULL || (t = isGR(items[p])) < 0) {
		sprintf(errorMsg, "%3d行目: 第１オペランドは GR0〜GR7 を指定しなければなりません", lineNo);
		displayError(errorMsg);
		errorFlag = TRUE;
		goto execAsm0_term;
	}
	ope1 |= (t << 4);
	p++;

	if (items[p] != NULL && strcmp(items[p], ",") != 0) {
		sprintf(errorMsg, "%3d行目: 第１オペランド後の ,（カンマ）がありません", lineNo);
		displayError(errorMsg);
		nError++;
		goto execAsm0_term;
	}
	p++;

	if (items[p] == NULL) {
		sprintf(errorMsg, "%3d行目: 第２オペランドがありません", lineNo);
		displayError(errorMsg);
		goto execAsm0_term;
	}
	
	t = isGR(items[p]);
	if (0 <= t) {
		ope1 |= (0x08 | t);
		p++;
	} else {
		ope2 = getAddress(items[p]);
		if (errorFlag) {
			return address;
		}
		p++;

		if (items[p] == NULL) {
			goto execAsm0_term;
		}
		if (items[p] != NULL && strcmp(items[p], ",") != 0) {
			sprintf(errorMsg, "%3d行目: 第２オペランド後の ,（カンマ）がありません", lineNo);
			displayError(errorMsg);
			goto execAsm0_term;
		}
		p++;
		if (items[p] == NULL || (t = isXR(items[p])) < 0) {
			sprintf(errorMsg, "%3d行目: 第３オペランドは GR1〜GR7 でなければなりません", lineNo);
			displayError(errorMsg);
			goto execAsm0_term;
		}
		ope1 |= t;
		p++;
	}

	if (items[p] != NULL) {
		sprintf(errorMsg, "%3d行目: 行末にコメント以外の不正コードがあります", lineNo);
		displayError(errorMsg);
		goto execAsm0_term;
	}

execAsm0_term:
	fprintf(prn, "%04X: %04X %04X\t%s", address, ope1, ope2, inbuf);
	fwrite(&ope1, sizeof(word), 1, obj);
	fwrite(&ope2, sizeof(word), 1, obj);

	return address + getOpeSize(op);
}

word execAsm1(word address, int op, char *items[], int p)
{
	int		t;
	word	ope1;
	word	ope2 = 0;
	
	errorFlag = FALSE;
	ope1 = getOpeCode(op);
	p++;
	
	if (items[p] == NULL || (t = isGR(items[p])) < 0) {
		sprintf(errorMsg, "%3d行目: 第１オペランドは GR0〜GR7 を指定しなければなりません", lineNo);
		displayError(errorMsg);
		errorFlag = TRUE;
		goto execAsm1_term;
	}
	ope1 |= (t << 4);
	p++;

	if (items[p] != NULL && strcmp(items[p], ",") != 0) {
		sprintf(errorMsg, "%3d行目: 第１オペランド後の ,（カンマ）がありません", lineNo);
		displayError(errorMsg);
		nError++;
		goto execAsm1_term;
	}
	p++;

	if (items[p] == NULL) {
		sprintf(errorMsg, "%3d行目: 第２オペランドがありません", lineNo);
		displayError(errorMsg);
		goto execAsm1_term;
	}
	ope2 = getAddress(items[p]);
	if (errorFlag) {
		return address;
	}
	p++;

	if (items[p] == NULL) {
		goto execAsm1_term;
	}
	if (items[p] != NULL && strcmp(items[p], ",") != 0) {
		sprintf(errorMsg, "%3d行目: 第２オペランド後の ,（カンマ）がありません", lineNo);
		displayError(errorMsg);
		goto execAsm1_term;
	}
	p++;
		if (items[p] == NULL || (t = isXR(items[p])) < 0) {
		sprintf(errorMsg, "%3d行目: 第３オペランドは GR1〜GR7 でなければなりません", lineNo);
		displayError(errorMsg);
		goto execAsm1_term;
	}
	ope1 |= t;
	p++;

	if (items[p] != NULL) {
		sprintf(errorMsg, "%3d行目: 行末にコメント以外の不正コードがあります", lineNo);
		displayError(errorMsg);
		goto execAsm1_term;
	}

execAsm1_term:
	fprintf(prn, "%04X: %04X %04X\t%s", address, ope1, ope2, inbuf);
	fwrite(&ope1, sizeof(word), 1, obj);
	fwrite(&ope2, sizeof(word), 1, obj);

	return address + getOpeSize(op);
}

word execAsm2(word address, int op, char *items[], int p)
{
	int		t;
	word	ope1;
	word	ope2 = 0;
	
	errorFlag = FALSE;
	ope1 = getOpeCode(op);
	p++;
	
	if (items[p] == NULL) {
		sprintf(errorMsg, "%3d行目: 第１オペランドがありません", lineNo);
		displayError(errorMsg);
		goto execAsm2_term;
	}
	ope2 = getAddress(items[p]);
	if (errorFlag) {
		return address;
	}
	p++;

	if (items[p] == NULL) {
		goto execAsm2_term;
	}
	if (items[p] != NULL && strcmp(items[p], ",") != 0) {
		sprintf(errorMsg, "%3d行目: 第１オペランド後の ,（カンマ）がありません", lineNo);
		displayError(errorMsg);
		goto execAsm2_term;
	}
	p++;
	if (items[p] == NULL || (t = isXR(items[p])) < 0) {
		sprintf(errorMsg, "%3d行目: 第２オペランドは GR1〜GR7 でなければなりません", lineNo);
		displayError(errorMsg);
		goto execAsm2_term;
	}
	ope1 |= t;
	p++;

	if (items[p] != NULL) {
		sprintf(errorMsg, "%3d行目: 行末にコメント以外の不正コードがあります", lineNo);
		displayError(errorMsg);
		goto execAsm2_term;
	}

execAsm2_term:
	fprintf(prn, "%04X: %04X %04X\t%s", address, ope1, ope2, inbuf);
	fwrite(&ope1, sizeof(word), 1, obj);
	fwrite(&ope2, sizeof(word), 1, obj);

	return address + getOpeSize(op);
}

word execAsm3(word address, int op, char *items[], int p)
{
	int		t;
	word	ope1;
	word	ope2 = 0;
	
	errorFlag = FALSE;
	ope1 = getOpeCode(op);
	p++;
	
	if (items[p] == NULL || (t = isGR(items[p])) < 0) {
		sprintf(errorMsg, "%3d行目: 第１オペランドは GR0〜GR7 を指定しなければなりません", lineNo);
		displayError(errorMsg);
		errorFlag = TRUE;
		goto execAsm3_term;
	}
	ope1 |= (t << 4);
	p++;

	if (items[p] != NULL) {
		sprintf(errorMsg, "%3d行目: 行末にコメント以外の不正コードがあります", lineNo);
		displayError(errorMsg);
		goto execAsm3_term;
	}

execAsm3_term:
	fprintf(prn, "%04X: %04X %04X\t%s", address, ope1, ope2, inbuf);
	fwrite(&ope1, sizeof(word), 1, obj);
	fwrite(&ope2, sizeof(word), 1, obj);

	return address + getOpeSize(op);
}

word execAsm4(word address, int op, char *items[], int p)
{
	word	ope1;
	word	ope2 = 0;
	
	errorFlag = FALSE;
	ope1 = getOpeCode(op);
	p++;
	
	if (items[p] == NULL) {
		sprintf(errorMsg, "%3d行目: 第１オペランドがありません", lineNo);
		displayError(errorMsg);
		goto execAsm4_term;
	}
	ope2 = getAddress(items[p]);
	if (errorFlag) {
		return address;
	}
	p++;

	if (items[p] != NULL) {
		sprintf(errorMsg, "%3d行目: 行末にコメント以外の不正コードがあります", lineNo);
		displayError(errorMsg);
		goto execAsm4_term;
	}

execAsm4_term:
	fprintf(prn, "%04X: %04X %04X\t%s", address, ope1, ope2, inbuf);
	fwrite(&ope1, sizeof(word), 1, obj);
	fwrite(&ope2, sizeof(word), 1, obj);

	return address + getOpeSize(op);
}

/*	START	*/
word execAsm5(word address, int op, char *items[], int p)
{
	word	ope1;
	word	ope2 = 0;
	
	errorFlag = FALSE;
	ope1 = getOpeCode(op);
	p++;
	
	if (items[p] == NULL) {
		goto execAsm5_term;
	}
	p++;
	
	if (items[p] == NULL) {
		sprintf(errorMsg, "%3d行目: 第１オペランドがありません", lineNo);
		displayError(errorMsg);
		goto execAsm5_term;
	}
	ope2 = getAddress(items[p]);
	if (errorFlag) {
		return address;
	}
	p++;

	if (items[p] != NULL) {
		sprintf(errorMsg, "%3d行目: 行末にコメント以外の不正コードがあります", lineNo);
		displayError(errorMsg);
		goto execAsm5_term;
	}

execAsm5_term:
	fprintf(prn, "%04X:          \t%s", address, inbuf);

	return address + getOpeSize(op);
}

/*	RET, etc	*/
word execAsm6(word address, int op, char *items[], int p)
{
	word	ope1;
	word	ope2 = 0;
	
	errorFlag = FALSE;
	ope1 = getOpeCode(op);
	p++;
	
	if (items[p] != NULL) {
		sprintf(errorMsg, "%3d行目: 行末にコメント以外の不正コードがあります", lineNo);
		displayError(errorMsg);
		goto execAsm6_term;
	}

execAsm6_term:
	if (ope1 != CMD_END) {
		fprintf(prn, "%04X: %04X %04X\t%s", address, ope1, ope2, inbuf);
		fwrite(&ope1, sizeof(word), 1, obj);
		fwrite(&ope2, sizeof(word), 1, obj);
	} else {
		fprintf(prn, "%04X:          \t%s", address, inbuf);
	}

	return address + getOpeSize(op);
}

/*	DS	*/
word execAsm7(word address, int op, char *items[], int p)
{
	int		i, n;
	word	ope = 0;

	p++;
	if (items[p] != NULL) {
		n = getWord(items[p]);
		if (0 < n) {
			for (i = 0; i < n; i++) {
				if (i == 0) {
					fprintf(prn, "%04X: %04X     \t%s", address, ope, inbuf);
				} else {
					fprintf(prn, "%04X: %04X     \t\n", address, ope);
				}
				fwrite(&ope, sizeof(word), 1, obj);
				address++;
			}
		} else {
			sprintf(errorMsg, "%3d行目: 領域数の指定が不正です", lineNo);
			displayError(errorMsg);
		}
		p++;
		if (items[p] != NULL) {
			sprintf(errorMsg, "%3d行目: 行末にコメント以外の不正コードがあります", lineNo);
			displayError(errorMsg);
		}		
	} else {
		sprintf(errorMsg, "%3d行目: 領域数の指定がありません", lineNo);
		displayError(errorMsg);
	}

	return address;
}

/*	DC	*/
word execAsm8(word address, int op, char *items[], int p)
{
	char	*s;
	word	ope = 0;
	int		sFlag = TRUE;
	
	p++;
	if (items[p] != NULL) {
		if (*items[p] != '\'') {
			while (items[p] != NULL) {
				if (*items[p] != ',') {
					ope = getWord(items[p]);
					if (sFlag) {
						fprintf(prn, "%04X: %04X     \t%s", address, ope, inbuf);
						sFlag = FALSE;
					} else {
						fprintf(prn, "%04X: %04X\n", address, ope);					
					}
					fwrite(&ope, sizeof(word), 1, obj);
					address++;
				}
				p++;
			}
		} else {
			s = items[p] + 1;
			while (*s != NUL && *s != '\'') {
				ope = (word) *s;
				if (sFlag) {
					fprintf(prn, "%04X: %04X     \t%s", address, ope, inbuf);
					sFlag = FALSE;
				} else {
					fprintf(prn, "%04X: %04X\n", address, ope);
				}				
				fwrite(&ope, sizeof(word), 1, obj);
				s++;
			}
			p++;
		}
		if (items[p] != NULL) {
			sprintf(errorMsg, "%3d行目: 行末にコメント以外の不正コードがあります %s", lineNo, items[p]);
			displayError(errorMsg);
		}		
	} else {
		sprintf(errorMsg, "%3d行目: 定数の指定がありません", lineNo);
		displayError(errorMsg);
	}

	return address;
}

word execAsm9(word address, int op, char *items[], int p)
{
	int		t;
	word	ope1;
	word	ope2 = 0;
	
	errorFlag = FALSE;
	ope1 = getOpeCode(op);
	p++;
	
	if (items[p] == NULL) {
		sprintf(errorMsg, "%3d行目: 第１オペランドがありません", lineNo);
		displayError(errorMsg);
		goto execAsm9_term;
	}
	ope2 = getAddress(items[p]);
	if (errorFlag) {
		return address;
	}
	p++;

	if (items[p] == NULL) {
		goto execAsm9_term;
	}
	if (items[p] != NULL && strcmp(items[p], ",") != 0) {
		sprintf(errorMsg, "%3d行目: 第１オペランド後の ,（カンマ）がありません", lineNo);
		displayError(errorMsg);
		goto execAsm9_term;
	}
	p++;
	if (items[p] == NULL || (t = getAddress(items[p])) == 0) {
		sprintf(errorMsg, "%3d行目: 第２オペランドは入出力語数(1〜255)でなければなりません", lineNo);
		displayError(errorMsg);
		goto execAsm9_term;
	}
	ope1 |= t;
	p++;

	if (items[p] != NULL) {
		sprintf(errorMsg, "%3d行目: 行末にコメント以外の不正コードがあります", lineNo);
		displayError(errorMsg);
		goto execAsm9_term;
	}

execAsm9_term:
	fprintf(prn, "%04X: %04X %04X\t%s", address, ope1, ope2, inbuf);
	fwrite(&ope1, sizeof(word), 1, obj);
	fwrite(&ope2, sizeof(word), 1, obj);

	return address + getOpeSize(op);
}
