/*
**	utils.c
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "opencasl.h"

void makeObjName(char *s, char *d)
{
	changeExt(s, d, "obj");
}

void makePrnName(char *s, char *d)
{
	changeExt(s, d, "prn");
}

void makeSymName(char *s, char *d)
{
	changeExt(s, d, "sym");
}

void changeExt(char *s, char *d, char *e)
{
	int		flag = FALSE;

	while (*s) {
		if (*s == '.') {
			flag = TRUE;
		}
		*d++ = *s++;
	}
	if (flag) {
		d--;
		while (*d != '.') {
			d--;
		}
	}
	*d++ = '.';
	while ((*d++ = *e++) != NUL)
		;
}

int isGR(char *s)
{
	int		result = ERROR;
	
	if (strncmp(s, "GR", 2) == 0) {
		s += 2;
		if (isdigit(*s) && isAllDigit(s)) {
			result = atoi(s);
			if (result < 0 && 7 < result) {
				result = ERROR;
			}
		}
	} else {
		result = ERROR;
	}
	return result;
}

int isXR(char *s)
{
	int		result = ERROR;
	
	if (strncmp(s, "GR", 2) == 0) {
		s += 2;
		if (isdigit(*s) && isAllDigit(s)) {
			result = atoi(s);
			if (result < 1 && 7 < result) {
				result = ERROR;
			}
		}
	} else {
		result = ERROR;
	}
	return result;
}

word getWord(char *s)
{
	word	result = 0;

	if (*s == '#' && isAllXDigit(s)) {
		result = htow(s + 1);
	} else if (isAllDigit(s)) {
		result = atoi(s);
	}
	return result;
}

word htow(char *s)
{
	int		result = 0;
	
	sscanf(s, "%X", &result);
	
	return (word) result;
}

int isAllDigit(char *s)
{
	int		result = TRUE;

	if (!(isdigit(*s) || *s == '-' || *s == '+')) {
		s++;
		while (*s) {
			if (!isdigit(*s)) {
				result = FALSE;
				break;
			}
			s++;
		}
	}
	return result;
}

int isAllXDigit(char *s)
{
	int		result = TRUE;

	if (!(isxdigit(*s) || *s == '#')) {
		s++;
		while (*s) {
			if (!(isxdigit(*s))) {
				result = FALSE;
				break;
			}
			s++;
		}
	}
	return result;
}

void printItems(char *items[])
{
	int		i;
	
	for (i = 0; items[i] != NULL; i++) {
		printf("%2d: \"%s\"\n", i, items[i]);
	}
}
