#ifndef	__opencomet_h
#define	__opencomet_h
/*
**	OPENCOMET.H
*/
#ifndef	TRUE
#define	TRUE	1
#endif

#ifndef	FALSE
#define	FALSE	0
#endif

#ifndef	NUL
#define	NUL		'\0'
#endif

#define	ERROR	(-1)
#define	NOERROR	0

#define	MAXNAME		32
#define	MAXLABEL	128
#define	MAXITEMS	16
#define	ORGADDR		0x0010
#define	MEMSIZE		0x1000

#define	CMD_NOP		0x0000
#define	CMD_LD		0x0100
#define	CMD_ST		0x0200
#define	CMD_LAD		0x0300
#define	CMD_ADDA	0x0400
#define	CMD_ADDL	0x0500
#define	CMD_SUBA	0x0600
#define	CMD_SUBL	0x0700
#define	CMD_AND		0x0800
#define	CMD_OR		0x0900
#define	CMD_XOR		0x0a00
#define	CMD_CPA		0x0b00
#define	CMD_CPL		0x0c00
#define	CMD_SLA		0x0d00
#define	CMD_SRA		0x0e00
#define	CMD_SLL		0x0f00
#define	CMD_SRL		0x1000
#define	CMD_JPL		0x1100
#define	CMD_JMI		0x1200
#define	CMD_JNZ		0x1300
#define	CMD_JZE		0x1400
#define	CMD_JOV		0x1500
#define	CMD_JUMP	0x1600
#define	CMD_PUSH	0x1700
#define	CMD_POP		0x1800
#define	CMD_CALL	0x1900
#define	CMD_RET		0x1a00
#define	CMD_INPUT	0x1b00
#define	CMD_OUTPUT	0x1c00
#define	CMD_RPUSH	0x1d00
#define	CMD_RPOP	0x1e00
#define	CMD_SVC		0x1f00
#define	CMD_IN		0x2000
#define	CMD_OUT		0x2100
#define	CMD_EXIT	0x2200
#define	CMD_START	0x2300
#define	CMD_END		0x2400
#define	CMD_DS		0x2500
#define	CMD_DC		0x2600
#define	CMD_MASK	0xff00

#define	GR0			0x0000
#define	GR1			0x0010
#define	GR2			0x0020
#define	GR3			0x0030
#define	GR4			0x0040
#define	GR5			0x0050
#define	GR6			0x0060
#define	GR7			0x0070
#define	GR_MASK		0x00f0

#define	GR20		0x0008
#define	GR21		0x0009
#define	GR22		0x000a
#define	GR23		0x000b
#define	GR24		0x000c
#define	GR25		0x000d
#define	GR26		0x000e
#define	GR27		0x000f
#define	GR2_MASK	0x0008

#define	XR1			0x0001
#define	XR2			0x0002
#define	XR3			0x0003
#define	XR4			0x0004
#define	XR5			0x0005
#define	XR6			0x0006
#define	XR7			0x0007
#define	XR_MASK		0x000f

#define	ZFLG		0x0001
#define	SFLG		0x0002
#define	OFLG		0x0004

typedef	unsigned char	byte;
typedef	short			word;
typedef	unsigned short	uword;

#define	MINWORD		(-32768)
#define	MAXWORD		32767
#define	MAXUWORD	65535

typedef	struct	tag_mnemonic {
	word	opeCode;
	int		opeType;
	int		opeSize;
	char	key[MAXNAME];
} MNEMONIC;

typedef	struct	tag_label {
	char	name[MAXNAME];
	word	address;
} LABEL;

typedef	struct	tag_mem {
	word	mem;
	word	bp;
} MEMORY;

/*	oce.c	*/
void oce(char *fname);
int loadObject(char *fname);
int loadSymbol(char *fname);
void executeDebug();
void dispHelp();
void dispDebugCommand();

/*	command.c	*/
void executeDump(int n, char *items[]);
void executeList(int n, char *items[]);
void executeStep(int n, char *items[]);
void executeSetRegister(int n, char *items[]);
void executeRun(int n, char *items[]);
void executeSetBP(int n, char *items[]);
void executeClearBP(int n, char *items[]);

/*	cpu.c	*/
void initMemory();
void initEnvironment();
void clearMemory();
void clearBreakPoint();
void deleteMemory();
void setMem(word address, word value);
word getMem(word address);
void setBP(word address, int count);
int getBP(word address);
void setPR(word address);
word getPR();
void setFlag(word flag);
word getFlag();
void setReg(int n, word value);
word getReg(int n);
void pushData(word val);
word popData();
void printCPU();

/*	labels.c	*/
int initLabel();
void deleteLabel();
int readLabel(char* fname);
int searchLabel(char *buf, word address);
word searchAddress(char *buf);
void getTarget(char *buf, word address);
word getOpe1(char *s);

/*	execute.c	*/
int execute(word address);
void setFLAG(word s);
void setOFLAG(int flag);
void executeStep();

/*	mnemonic.c	*/
int disAssem(char *buf, word address);
void linePrint();
word getOpeCode(int pos);
int getOpeType(int pos);
int getOpeSize(int pos);

/*	utils.c		*/
void makeObjName(char *s, char *d);
void makeSymName(char *s, char *d);
void changeExt(char *s, char *d, char *e);
word htow(char *s);
void removeEOL(char *s);
void upperCase(char *s);

/*	dividString.c	*/
int getCommandLine(char *items[], char *s);


#endif
